<template>
    <div class="flex">
        <button type="button" v-if="" class="btn btn-primary btn-lg add" @click.prevent="addListing">Add</button>
        <div class="flex-wrapper">
            <div class="listings">
                <ul class="list-group">
                    <li class="list-group-item" v-for="listing in listings" :key="listing.id">
                        <Listing v-bind="listing"></Listing>
                    </li>
                </ul>
            </div>
            <div class="sorting">
                <ul class="list-group">
                    <li class="list-group-item">
                        <div class="form-group">
                            <label for="title">Title</label>
                            <input type="text" class="form-control" id="title" placeholder="Title" v-model="form.title">
                            <div class="alert alert-danger" v-if="form.errors.has('title')"
                                 v-text="form.errors.get('title')"></div>
                        </div>
                    </li>
                    <li class="list-group-item">
                        <div class="form-group">
                            <label for="description">Description</label>
                            <input type="text" class="form-control" id="description" placeholder="description"
                                   v-model="form.description">
                            <div class="alert alert-danger" v-if="form.errors.has('description')"
                                 v-text="form.errors.get('description')"></div>
                        </div>
                    </li>
                    <li class="list-group-item">
                        <div class="form-group">
                            <label for="address">Address</label>
                            <input type="text" class="form-control" id="address" placeholder="address"
                                   v-model="form.address">
                            <div class="alert alert-danger" v-if="form.errors.has('address')"
                                 v-text="form.errors.get('address')"></div>
                        </div>
                    </li>
                    <li class="list-group-item">
                        <div class="form-group">
                            <label for="rooms">Rooms</label>
                            <input type="number" class="form-control" id="rooms" placeholder="1" v-model="form.rooms">
                            <div class="alert alert-danger" v-if="form.errors.has('rooms')"
                                 v-text="form.errors.get('rooms')"></div>
                        </div>
                    </li>
                    <li class="list-group-item">
                        <div class="form-group">
                            <label for="priceMin">Price Min</label>
                            <input type="number" class="form-control" id="priceMin" placeholder="0"
                                   v-model="form.priceMin">
                            <div class="alert alert-danger" v-if="form.errors.has('priceMin')"
                                 v-text="form.errors.get('priceMin')"></div>
                        </div>

                        <div class="form-group">
                            <label for="priceMax">Price Max</label>
                            <input type="number" class="form-control" id="priceMax" placeholder="10000"
                                   v-model="form.priceMax">
                            <div class="alert alert-danger" v-if="form.errors.has('priceMax')"
                                 v-text="form.errors.get('priceMax')"></div>
                        </div>


                    </li>
                    <li class="list-group-item">
                        <label for="orderBy">Order By</label>
                        <select class="form-control form-control-sm" id="orderBy" v-model="form.orderBy">
                            <option>title</option>
                            <option>description</option>
                            <option>address</option>
                            <option>price</option>
                            <option>rooms</option>
                        </select>
                        <div class="alert alert-danger" v-if="form.errors.has('orderBy')"
                             v-text="form.errors.get('orderBy')"></div>
                    </li>

                    <li class="list-group-item">
                        <label for="direction">Direction</label>
                        <select class="form-control form-control-sm" id="direction" v-model="form.direction">
                            <option>asc</option>
                            <option>desc</option>
                        </select>
                        <div class="alert alert-danger" v-if="form.errors.has('direction')"
                             v-text="form.errors.get('direction')"></div>
                    </li>

                </ul>
                <div class="buttons">
                    <button type="submit" class="btn btn-primary filterbtn" :disabled="form.errors.any()"
                            @click="submit">Filter
                    </button>
                    <button type="submit" class="btn btn-danger resetbtn" @click="clearData">Reset</button>
                </div>

            </div>

        </div>

        <Paginator/>
    </div>
</template>

<script>
    import {mapGetters, mapState} from 'vuex'
    import Listing from "./Listing";
    import Paginator from "./Paginator";
    import Form from 'form-backend-validation';


    export default {
        name: "Homepage",
        components: {Paginator, Listing},
        data() {
            return {
                form: new Form({
                    description: '',
                    address: '',
                    title: '',
                    priceMin: '',
                    priceMax: '',
                    rooms: '',
                    orderBy: '',
                    direction: '',
                    page: 1,
                }, {
                    resetOnSuccess: false,
                    http: this.$http,
                }),
            }
        },
        computed: {
            ...mapState({
                listings: state => state.listings
            }),
            ...mapGetters([
                'currentPage',
                'lastPage',
                // ...
            ])
        },
        mounted() {
            this.$store.dispatch('setForm', this.form)
            this.$store.dispatch('getListings', this.form).then(response => this.onSuccess(response)).catch(response => this.onError(response));
        },
        methods: {
            clear() {
                this.form.errors.clear()
            },
            clearData() {
                this.form.reset()
                this.$store.dispatch('setForm', this.form)
            },
            submit() {
                this.$store.dispatch('getListings', this.form).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            },
            onFilterSuccess(response) {

            },
            addListing() {
                this.$router.push('/add-listing')
            },
            onSuccess(response) {
                this.$store.dispatch('setListings', response.data)
                this.$store.dispatch('setCurrentPage', response.current_page)
                this.$store.dispatch('setLastPage', response.last_page)
            },
            onError(response) {
                console.log(response)
            }
        }

    }
</script>

<style scoped>
    .filterbtn {
        margin-top: 10px;

        margin-right: 10px;
        width: 130px
    }

    .resetbtn {
        margin-top: 10px;

        margin-left: 10px;
        width: 130px
    }

    .buttons {
        display: flex;
        flex-direction: row;
        justify-content: space-between;
    }

    .btn {
        /*margin-top: 10px;*/
    }

    .btn-group {

    }

    .sorting {
        display: flex;
        flex-direction: column;
        width: 300px;
        margin-left: 50px;
    }

    .listings {
        display: flex;
        width: 80%;
    }

    .flex-wrapper {
        display: flex;
        flex-direction: row;
        justify-content: space-between;
        margin-left: 50px;
        margin-right: 50px;
    }


    .flex {
        display: flex;
        flex-direction: column;


    }

    .add {
        align-self: flex-end;
        width: 200px;
        margin-right: 90px;
        margin-bottom: 15px;
    }
</style>
